!!
=======================================================================================
 Description ...: Tab Generator
 Requirement(s).: RFO BASIC!
 Author ........: Giovanni Rossati (El Condor)
 Version........: 0.1.0
 Date...........: 11 October 2017
 License........: Free to use without any warranties
=======================================================================================
!!
fn.def createTab(parameter$)
	Screen.size, sSize[]
	w = sSize[1] * 0.9
	h = sSize[2] * 0.9
	p = 0	% tab position
	wTab = 160
	hTab = 50
	squareArc = 10	% is the radius
	offsetX = sSize[1] * 0.05
	offsetY = sSize[2] * 0.05
	color$ = "FFFCFCFC"		% background color
	border$ = "FF7F7F7F"	% border color
	bundle.create answer
	re$ = "[aAbBcCdDeEfF\\d]{8}"
	title$ = ""
	SPLIT field$[], parameter$, ","
	ARRAY.LENGTH n, field$[]
	for i = 1 to n
		parm$ = UPPER$(WORD$(field$[i],1,"\\s*=\\s*"))
		value$ = WORD$(field$[i],2,"\\s*=\\s*")
		if parm$ = "WIDTH" Then w = VAL(value$)
		if parm$ = "HEIGHT" Then h = VAL(value$)
		if parm$ = "POSITION" Then p = VAL(value$) - 1
		if parm$ = "TITLE" Then TITLE$ = VALUE$
		if parm$ = "TOP" Then offsetY = VAL(VALUE$)
		if parm$ = "LEFT" Then offsetX = VAL(VALUE$)
		if parm$ = "COLOR" Then 
			if matchRE(VALUE$,re$) Then color$ = VALUE$
		Endif
		if parm$ = "BORDER" Then
			if matchRE(VALUE$,re$) Then border$ = VALUE$
		Endif
	next
	if title$ = "" Then title$ = "Tab " + STR$(p+1)
	list.Create N,lst
	list.add lst, (p+1)*wTab-squareArc,0, p*wTab, 0, p*wTab,hTab, 0,hTab, 0,h, w,h, w,hTab, (p+1)*wTab,hTab, (p+1)*wTab,squareArc
	gr.color HEX(LEFT$(color$,2)),HEX(MID$(Color$,3,2)),HEX(MID$(Color$,5,2)),HEX(RIGHT$(color$,2)),1
	gr.poly poly,lst,offsetX,offsetY
	gr.group g,poly
	gr.get.value g,"list",gList	% this is the grafic tab list
	bundle.put answer,"glist",gList
	bundle.put answer,"touch",USING$("","%d,%d,%d,%d",INT(offsetX+p*wTab),INT(offsetY),INT(offsetX+(p+1)*wTab),INT(offsetY+hTab))
	Gr.circle c, offsetX+(p+1)*wTab-squareArc, offsetY+squareArc, squareArc
	list.add gList,c
	% border
	list.size lst,n
	gr.color HEX(LEFT$(border$,2)),HEX(MID$(border$,3,2)),HEX(MID$(border$,5,2)),HEX(RIGHT$(border$,2)),0
	gr.set.stroke 2
	Gr.arc arc, offsetX+(p+1)*wTab-2*squareArc, offsetY, offsetX+(p+1)*wTab, offsetY+2*squareArc, 0, -90, false
	list.add gList,arc
	list.toarray lst,aPoints[]
	for i = 1 to n - 2 step 2
		gr.line ln,offsetX+aPoints[i],offsetY+aPoints[i+1],offsetX+aPoints[i+2],offsetY+aPoints[i+3]
		list.add gList,ln
	next
	gr.set.stroke 1
	GR.COLOR 255,40,40,40,3
	gr.text.size 24
	gr.text.align 2
	gr.text.draw lbl,offsetX+(p+0.5)*wTab,offsetY+hTab*0.7,title$
	list.add gList,lbl
	bundle.put answer,"label",lbl
	gr.render
	FN.RTN answer
fn.End
FN.DEF matchRE(field$,re$)	% retun true if match
	split a$[],"*"+field$+"*",re$
	array.length ll,a$[]
	FN.RTN ll-1
FN.END
FN.DEF getBundle$(b,k$)
	bundle.get b,k$,v$
	FN.RTN v$
FN.END
FN.DEF getBundle(b,k$)
	bundle.get b,k$,v
	FN.RTN v
FN.END
FN.DEF button(text$,left,top,width,height)	% return box
	gr.Color 255,255,255,255,1
	radius = INT(height*0.2)
	DIM aG[6]		% array of grafic items
	gr.text.align 2		% text centered
	gr.rect btn,left+radius,top,left+width-radius,top+height
	gr.group g,btn
	gr.get.value g,"list",gList	% this is the grafic tab list	
	gr.rect aG[1],left,top+radius,left+width,top+height-radius
	Gr.circle aG[2], left+radius,top+radius,radius
	Gr.circle aG[3], left+radius,top+height-radius,radius
	Gr.circle aG[4], left+width-radius,top+radius,radius
	Gr.circle aG[5], left+width-radius,top+height-radius, radius
	gr.Color 255,40,40,40,3
	gr.text.draw aG[6],left+0.5*width,top+0.6*height,text$
	list.add.array gList,aG[]
	FN.RTN gList
FN.END
FN.DEF testTouched$(touchs)
	answer$ = ""
	gr.touch touched, x, y
	if touched = 0 then FN.RTN ""
	DO 
		GR.TOUCH touched, x, y 
	UNTIL !touched
	BUNDLE.KEYS touchs, list
	LIST.SIZE list, size
	FOR i = 1 TO size 
		LIST.GET list, i, key$
		SPLIT a$[],getBundle$(touchs,key$), ","
		if (x > VAL(a$[1])) & (x < VAL(a$[3])) &  (y > VAL(a$[2])) & (y < VAL(a$[4])) Then
			answer$ = key$
			F_N.BREAK
		endif
	Next
	FN.RTN answer$
FN.END
FN.DEF changeTab(tabNumber,aGList[],otherGraphics)
	ARRAY.LENGTH numberOfTabs, aGList[]
	list.create N,newLst
	For i=1 to numberOfTabs
		if aGList[i] > 0 Then if i <> tabNumber Then list.add.list newLst,aGList[i]
	Next
	list.add.list newLst,aGList[tabNumber]
	if otherGraphics > 0 then list.add.list newLst,otherGraphics
	list.toArray newLst,newArr[]
	GR.newDL newArr[]
	GR.render
FN.END
GR.OPEN 255,0,0,0
GR.orientation 1
bundle.create touchs	% key = fieldname, dtaa = left, top, right, bottom
bundle.create tabs		% key = TabPosition, data = gList
array.load arrayGList[],0,0,0,0,0	% grafic list array of tabs
answer = createTab("Title=Onglet un,color=FFC0C0C0,position=1,width=600,height=400,LEFT=50,Top=50")
arrayGList[1] = getBundle(answer,"glist")
bundle.put touchs,"Tab1",getBundle$(answer,"touch")
gr.text.draw txt,150,300,"Onglet un"
list.add arrayGList[1],txt
answer = createTab("Title=Onglet deux,color=FFC0C000,position=2,width=600,height=400,LEFT=50,Top=50")
arrayGList[2] = getBundle(answer,"glist")
bundle.put touchs,"Tab2",getBundle$(answer,"touch")
gr.text.draw txt,150,300,"Onglet deux"
list.add arrayGList[2],txt
answer = createTab("Title=Onglet trois,border=FFC000C0,position=3,width=600,height=400,LEFT=50,Top=50")
arrayGList[3] = getBundle(answer,"glist")
bundle.put touchs,"Tab3",getBundle$(answer,"touch")
gr.text.draw txt,150,300,"Onglet trois"
list.add arrayGList[3],txt
btnList = button("End",250,500,200,60)
bundle.put touchs,"End","250,500,450,560"
gr.render
do
	tKey$ = testTouched$(touchs)
	if tKey$ <> "" Then
		if LEFT$(tKey$,3) = "Tab" Then
!			if tKey$ = "Tab2" Then gr.save "demoTab.jpg",90
			changeTab(VAL(MID$(tKey$,4)),arrayGList[],btnList)
		Endif
	Endif
until tKey$ = "End"
GR.CLOSE
print "See you later alligator"
END